"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var spy_adapter_factory_1 = require("./spy-adapter-factory");
var Mockery = (function () {
    function Mockery() {
    }
    Mockery.configure = function (spyAdapter) {
        this.spyAdapter = typeof spyAdapter === 'string' ? spy_adapter_factory_1.SpyAdapterFactory.get(spyAdapter) : spyAdapter;
    };
    Mockery.extend = function (object) {
        return this.withGenerator(object);
    };
    Mockery.of = function (stubs) {
        if (stubs === void 0) { stubs = {}; }
        return this.extend({}).with(stubs);
    };
    Mockery.staticMethod = function (object, key, stub) {
        this.spyAdapter.spyAndCallFake(object, key, stub);
    };
    Mockery.spyOnTheStubbedFunctions = function (object, key) {
        var _this = this;
        if (typeof object[key] === typeof Function) {
            this.spyAdapter.spyAndCallThrough(object, key);
        }
        else if (typeof object[key] === typeof {}) {
            Object.keys(object[key]).forEach(function (subKey) {
                _this.spyOnTheStubbedFunctions(object[key], subKey);
            });
        }
    };
    Mockery.withGenerator = function (object) {
        var _this = this;
        return {
            with: function (stubs) {
                if (stubs === void 0) { stubs = {}; }
                Object.keys(stubs).forEach(function (key) {
                    _this.spyOnTheStubbedFunctions(stubs, key);
                });
                return Object.assign(object, stubs);
            }
        };
    };
    Mockery.spyAdapter = spy_adapter_factory_1.SpyAdapterFactory.get('noop');
    return Mockery;
}());
exports.Mockery = Mockery;
//# sourceMappingURL=mockery.js.map